
/***************************************************
* By CCSC compiler
*  File Name: 20150430_K391_MK619B_1827.c
*  Description: generate prime number on 3-7segment
*  For PIC-P18-LCD2 with 16F1827
*  RA4 switch
*  RB0 LED
*  RB4-7 data for 7seg
*  RB3 digit for 7seg
*  RB2 digit for 7seg
*  COPYRIGHT 2015 MYCOMKITS.COM, owned by CNET LIMITED
*  $BEv%W%m%0%i%`$NCx:n8"$O!"@=:n<T!V%^%$%3%s%-%C%H%I%C%H%3%`1?1D!!M-8B2q<R%/%M%C%H!W$K5"B0$7$^$9!#(B
*  $BCx:n8"$rJ|4~$7$F$$$^$;$s$,!"Ev%W%m%0%i%`$r;H$C$?3X=,$NCf$G%W%m%0%i%`$r<+M3$KJQ99$7$F$*;H$$$/$@$5$$!#(B
***************************************************/
//
#include <16f1827.h>
#fuses	HS, NOWDT, MCLR, NOBROWNOUT, PUT, NOLVP, NOPROTECT, NODEBUG
#fuses	NOCPD, NOCLKOUT, NOWRT, NOIESO, NOFCMEN, PLL_SW, NOSTVREN
#use	delay(CLOCK = 20000000)
#use	rs232(BAUD = 9600, XMIT = PIN_A2, RCV = PIN_A3)
#include <math.h>
//
#define	Bmode 0x00			//port B all output
#define Amode 0xFB			//port A all input except A2
//////// Port define and link LCD library
#define DB7 PIN_B7
#define DB6 PIN_B6
#define DB5 PIN_B5
#define DB4 PIN_B4
#define RS PIN_B3		//Register Select
#define STB PIN_B2		//Strobe or Enable Signal
///
int pre_start = 1;
long number=0;
long number2=0;
int digit;
//
#separate
void disp_digit();
#separate
void initializing();
#separate
void test_serial();
#separate
void test_switch();
#separate
void test_prime();
//
void main()
{
    initializing();
    //
    while(1)
    {
        if (input(PIN_A4) == 0)	// start
        {
            delay_ms(50);
            if (input(PIN_A4) == 0)
            {
                while(1)
                {
                    test_prime();
                }
            }
        }
    }
}
//
#separate
void disp_digit()
{
    if((number2 & 0x01) == 0) output_low(PIN_B4);
    else output_high(PIN_B4);
    if((number2 & 0x02) == 0) output_low(PIN_B5);
    else output_high(PIN_B5);
    if((number2 & 0x04) == 0) output_low(PIN_B6);
    else output_high(PIN_B6);
    if((number2 & 0x08) == 0) output_low(PIN_B7);
    else output_high(PIN_B7);
}
//
#separate
void initializing()
{
    set_tris_a(Amode);	//all input
    set_tris_b(Bmode);	//all output
    //
    #use fast_io(A)
    #use fast_io(B)
    //
    setup_comparator(NC_NC_NC_NC);
    SETUP_DAC(DAC_OFF);
    // A/D converter initialize
    setup_adc_ports(NO_ANALOGS);	// gnd to 5.0V
    // initialize timer 1 for repeat play
    setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);	// clock 0.2us, one cycle 1.6us
    set_timer1(0xF2FB);              // setting almost 5msec
    enable_interrupts(INT_TIMER1);   // enable timer 1
    output_B(0x00);
    //
    enable_interrupts(GLOBAL);
}
// timer 1 sub function, count down timer value at every 10msec.
#int_timer1
void isr1(void)
{
    set_timer1(0xF2FB);	// setting timer 1. almost 5msec
    if(digit == 3)	// x1000 digit
    {
        digit = 2;	// change flag
        number2 = number / 1000;
        disp_digit();
        output_high(PIN_B3);	// A0 IN
        output_high(PIN_B2);	// A1 IN
    }
    else if(digit == 2)	// x100 digit
    {
        digit = 1;	// change flag
        number2 = number % 1000;
        number2 = number2 / 100;
        disp_digit();
        output_low(PIN_B3);	// A0 IN
        output_high(PIN_B2);	// A1 IN
    }
    else if(digit == 1)	// x10 digit
    {
    	digit = 0;	// change flag
    	number2 = number % 100;
    	number2 = number2 / 10;
        disp_digit();
    	output_high(PIN_B3);	// A0 IN
        output_low(PIN_B2);	// A1 IN
    }
    else 	// x1 digit
    {
    	digit = 3;	// change flag
    	number2 = number % 10;
        disp_digit();
    	output_low(PIN_B3);	// A0 IN
        output_low(PIN_B2);	// A1 IN
    }
}
// only for test
#separate
void test_serial()
{
    int cmnd;
    printf("\n\rPress Any Key=   ");
    cmnd=getc();
    printf("\n\rInput= ");
    putc(cmnd);
}
// only for test
#separate
void test_switch()
{
    if(input(PIN_A4)==0)
    {
        delay_ms(50);
        if(input(PIN_A4)==0)
        {
            if(pre_start==1)
            {
                output_toggle(PIN_B0);
                pre_start=0;
            }
        }
    }
    else pre_start=1;
}
// prime number
#separate
void test_prime()
{
    long i, j, k, m, n;
    k = 2;
    printf("%lu ", k );
    printf("%lu ", k+1 );
    n=3;
    for( i = 5 ; i <= 9999 ; i = i+2 )
    {
        m = sqrt(i);
        for( j = 3; j <= m; j = j+2)
        {
            if (i%j == 0) break;
        }
        if (i%j != 0)
        {
            printf("%lu ", i );
            number = i;
            n++;
            output_toggle(PIN_B0);
            while(input(PIN_A4) == 0) {}
            delay_ms(1000);
        }
    }
}
